package de.fraunhofer.iem.dataprovider.taskManager.tasks

import de.fraunhofer.iem.dataprovider.logger.getLogger
import java.util.*

enum class TaskType {
    REPO_CHANGED,
    DONE
}
interface ITask {
    val type: TaskType
    suspend fun execute()
}

sealed class Task(protected val taskID: UUID = UUID.randomUUID()): ITask {
    protected val logger = getLogger(javaClass)
}

class DoneTask(private val message: String? = null): Task() {
    override val type: TaskType = TaskType.DONE
    override suspend fun execute() {
        logger.info("[${Thread.currentThread().name}] I'm done $message")
    }
}
